# 關於CocoPi
CocoPi是CocoRobo開發的一款集成了多種感測器和功能的掌上計算器，可用於AloT教學、開發和實驗。
它運行Linux系統，支援Python和圖形化程式設計。
CocoPi搭載All Winners V831系列晶片，包含單核ARM Cortex-A7處理器和64MB DDR2晶片，晶片集成了H.264/H.265視訊轉碼器和影像處理演算法，能夠提供高效的視頻編碼和專業的圖像效果。

# 硬體資訊

## 硬體性能參數

| No.	| 内容 |     具體參數    |
| ----  | --------------| --------------|
|   1	|   CPU 	     |  Allwinner V831, ARM CortexTM-A7,800Mhz  |
|   2   |   DRAM	         |  SIP (System in Package) 64MB DDR2  |
|   3	|   NPU	     | 0.2TOPS，運算元支持：Conv, Activation, Pooling, BN, LRN, FC/Inner Product  |
|   4	|   存儲	  | SD卡（最高128GB，預設16GB）  |
|   5	|   啟動引導	|  SD卡  |
|   6	|   作業系統	 |  Maix-Linux |
|   7	|   Python版本  |  Python3.8.5  |
|   8	|   圖像輸入    |	一路MIPI CSI ，最高支援1080P@60fps (RAW格式)，預設連接200W圖元攝像頭  |
|   9	|   視頻輸出    |	1-路RGB 輸出，最高支援QVGA@60fps   |
|   10	|   音訊  |	集成音訊轉碼器，支援20位音訊輸入輸出； 揚聲器功率1W。  |
|   11	|   網路連接    |	2.4Ghz WIFI，最大穩定通信距離20m（非複雜電磁環境下開闊室內測量結果）   |
|   12	|   工作電壓    |	 5V直流輸入（通過USB口） 7V~12V直流輸入（通過電源輸入端子）  |
|   13	|   最大功率    |	5V直流輸入（通過USB口）  |
|   14	|   <div style="width:100px">板載外設</div>    |	 輸入類: 1個溫濕度感測器、1個三軸陀螺儀、1個麥克風、1個光敏感測器、4個按鍵、1個200W圖元攝像頭、1個RESET按鍵 <br/> 輸出類: 1個揚聲器、一個2.8英寸全彩IPS液晶螢幕、1個RGB燈、1個藍色LED燈 · 接口類別    1路IIC接口、1路UART接口、1路SPI接口、 1路USB-OTG Type-C接口、1路USB-A 2.0接口、 4路GPIO接口    2個PWM控制器（8通道）、2個直流馬達接口 <br/>  其他    1個內置RTC    |


## 硬體主要部件

<div style="width:100%;text-align:center;margin-bottom:20px;">
    <img src="media\開始使用CocoPi\hardware_1.jpg" width="500"><br/>
</div>

<div style="width:100%;text-align:center;margin-bottom:20px;">
    <img src="media\開始使用CocoPi\hardware_2.jpg" width="500"><br/>
</div>

| No.	|           部件名稱             |  部件描述                |
| ----  | ------------------------  | ------------------------ |
|     1/2/3/4	     |  按鍵開關  | A/B/C/D號按鍵開關（詳見硬體標注）。 |
|       5	         |  揚聲器  | “喇叭”，是一種把電信號轉變為聲信號的換能器件。 |
|     6	     | RESET按鍵  | 按下此按鈕控制硬體重新開機。 |
|   7	  |  馬達驅動晶片  | 用於驅動馬達。 |
|   8	|  相機  | 可切換廣角/定焦攝像頭安裝，用於獲取圖像。|
| 9	|  核心處理器 | 硬體的核心處理器，具體參數見“硬體性能參數”。|
|  10  |	Wi-Fi晶片 | 集成Wi-Fi功能的控制器。|
|  11  |	Wi-Fi天線  | 用於增強硬體無線傳輸信號。|
|  12  |	RGB燈   | 全彩LED燈，通過程式控制顯示。|
|  13  |	溫濕度感測器 | 用於監測周邊環境的溫度（攝氏）和濕度資料。|
|  14  |	運動感測器（陀螺儀）   | 用於檢測硬體的空間運動。|
|  15  |	 麥克風 | 採集環境音訊資料。|
|  16  |	光照感測器  | 內置光敏電阻，用於監測周邊環境的光照強度。|
|  17  |	螢幕    | 全彩IPS液晶螢幕，尺寸為2.8英寸。|


## 硬體主要接口

### - 接口簡介

<div style="width:100%;text-align:center;margin-bottom:20px;">
    <img src="media\開始使用CocoPi\hardware_3.jpg" width="500"><br/>
</div>

| No.	|           接口名稱             |   接口描述                |
| ----  | ------------------------  | ------------------------ |
|      1	 |  Type C數據接口  |  通過Type C資料線實現與PC端通信。 |
|      2	 |  Micro SD卡槽  |  用於連接Micro SD存儲卡，存儲媒體、程式檔、機器學習模型等資料。 |
|     3/6	 | 伺服馬達接口  | 用於接入伺服馬達或感測器使用，可以獲取感測器輸入的數位信號。 |
|     4/5	 |  馬達接口  | 用於接入直流馬達使用。 |
|      7	 |  USB資料接口 | 通過USB資料線連接外接設備，如滑鼠、顯示器等。 |
|      8	 |  POWER電源接口 | 通過外接電源進行硬體供電。 |
|      9     |	GPIO接口  | 通用輸入/輸出接口，用於連接外部感測器作為輸入/輸出。|
|      10    |	SPI通信接口  | 串列外設接口，典型應用有快閃記憶體、EEPROM、SD卡與液晶顯示器。 |
|      11    |	UART串口通信接口   | 通用非同步收發傳輸器，主要用於CocoPi與其他硬體進行資料傳輸。 |
|      12    |	IIC通信接口 |  串列通訊匯流排，主要應用在構造簡單且可以犧牲傳送速率來降低製造成本的外部設備上。 |

### 接口模式

ADC模式：用於接類比量感測器，輸入輸入範圍：0~1023。常見ADC感測器：旋鈕、搖杆滑塊、紅外巡線感測器、光敏電阻感測器、音量檢測感測器、土壤濕度感測器類比溫度感測器等。

GPIO模式：在輸入模式下，可以用於連接按鈕、紅外避障感測器、行程開關、傾斜感測器等；在輸出模式下，可以用來點燈、控制電磁繼電器、控制蜂鳴器等。

PWM模式：引腳可以用來輸出PWM波，進行諸如呼吸燈、小風扇馬達轉速控制等。 通用非同步收發設備模式：模組可以用於連接協力廠商設備或者感測器進行串口通訊，如Arduino、Micro： bit、樹莓派、ESP32等協力廠商設備。

SPI模式：模組可以連接協力廠商設備或者感測器進行SPI通訊，此外很多小螢幕是基於SPI進行通訊。

IIC模式：模組可以連接協力廠商設備可者感測器進行IIC通訊，如連接PCA9685進行馬達、伺服馬達擴展控制、連接顏色感測器、人體紅外感測器、磁力計等。

注意：所有GPIO的電壓域為0V~3V3，輸入電壓不能超運以免造成引腳損壞甚至晶片損壞3V3。


### 接口連接

<div style="width:100%;text-align:center;margin-bottom:20px;">
    <img src="media\開始使用CocoPi\hardware_4.jpg" width="500"><br/>
</div>

|    類型             |   使用説明                |
| ------------------------  | ------------------------ |
|  PH2.0 3P轉母頭杜邦線  |  用於S1/S2接口轉接 |
|  SH1.0 6P轉母頭杜邦線  |  用於GPIO接口/SPI通訊接口轉接 |
|  SH1.0 4P轉母頭杜邦線  |  用於UART串口通訊接口/IIC通訊接口轉接 |
